#include <stdlib.h>
#include <string.h>

#include "musicbrainz-lib.h"

int do_add_artist(struct MBState * mbs)
{
  /*
  struct MBState * mbs ;
  */
  struct MBArtistInfo artist;
  /*
  int login_status;
  */

  MBID mbid_out;

  mb_init_ArtistInfo(&artist);

  char * mbid = "2296a413-01fb-4900-a0cc-9e721ed6556f";
  /*
  */

  artist.artist_name = "Swampwalk";
  artist.sort_name = "Swampwalk";

  artist.area_id = 7961;

  /*
  artist.disambiguation = "New York";
  artist.not_dupe = 1;
  artist.type = Group;
  */

  artist.url_count = 1;
  artist.urls = malloc(sizeof(struct MBURL) * artist.url_count);
  artist.urls[0].type = 192;
  artist.urls[0].address = "https://www.facebook.com/swampwalkin";

  /*
  artist.urls[0].type = 291;
  artist.urls[0].address = "https://soundcloud.com/leminomusic";
  artist.urls[2].type = 192;
  artist.urls[2].address = "https://twitter.com/leminomusic";
  artist.urls[3].type = 192;
  artist.urls[3].address = "https://www.reverbnation.com/leminomusic";
  artist.urls[4].type = 193;
  artist.urls[4].address = "https://www.youtube.com/minodubstep";

  artist.urls[0].type = 183;
  artist.urls[0].address = "http://le-mino.com/";
  artist.urls[1].type = 180;
  artist.urls[1].address = "http://www.discogs.com/artist/3592442";
  artist.urls[0].type = 718;
  artist.urls[0].address = "http://jackwilsonmc.bandcamp.com/";
  artist.urls[2].type = 192;
  artist.urls[2].address = "https://twitter.com/slowdangerslow";
  artist.urls[0].type = 291;
  artist.urls[0].address = "https://soundcloud.com/negationnyc";
  artist.urls[0].type = 192;
  artist.urls[0].address = "https://www.facebook.com/pages/Venus-in-Furs/";
  artist.urls[0].type = 189;
  artist.urls[0].address = "https://myspace.com/venus.in.furs";
  */

  /*
  artist.relationship_count = 1;
  artist.relationships = malloc(sizeof(struct MBRelationship) * 
				artist.relationship_count);
  artist.relationships[0].type = 103;
  strcpy(artist.relationships[0].musicbrainzID,
	 "f6637789-4816-4280-8260-1dd34fec9435");
  artist.relationships[1].type = 103;
  strcpy(artist.relationships[1].musicbrainzID,
	 "c42d171e-4ee1-4c0b-8411-f340c7802b90");
  */

  mb_add_artist(mbs, artist, &mbid_out);
  /*
  mb_update_artist(mbs, mbid, artist);
  */

  /*
  free(artist.urls);
  */
}

int do_add_place(struct MBState * mbs)
{
  struct MBPlace place;
  MBID place_mbid;
  int login_status;

  mb_init_Place(&place);

  /*
  char * mbid = "2f517f26-fc74-435f-b54f-ad4666d165a7";
  */

  char * area_mbid = "787abc26-28ce-44f8-a2d1-82d86b5d28a8";

  place.name = "Garfield Artworks";
  place.type = 2;
  place.area_id = lookup_area(mbs, area_mbid);
  /*
  place.address = "66 Greenpoint Ave";
  place.disambiguation = "Greenpoint";
  */

  /*
  place.url_count = 1;
  place.urls = malloc(sizeof(struct MBURL) * place.url_count);
  place.urls[0].type = 363;
  place.urls[0].address = "http://tendertrapbk.com/";
  */

  /*
  place.urls[0].type = 429;
  place.urls[0].address = "https://www.facebook.com/SolasBarNYC";
  */
  
  mb_add_place(mbs, place, &place_mbid);
  /*
  free(place.urls);
  */
}

int main(void)
{
  struct MBState * mbs ;
  struct MBEventInfo event;
  int login_status;
  MBID mbid;

  mb_init_EventInfo(&event);

  /*
  char * mbid = "2f517f26-fc74-435f-b54f-ad4666d165a7";
  */

  event.name = "Nothing Changes 2/10/16";
  event.type = eventConcert;
  event.begin_year = 2016;
  event.begin_month = 02;
  event.begin_day = 10;
  event.end_year = 2016;
  event.end_month = 02;
  event.end_day = 10;
  event.time = "23:00";

  strcpy(event.venue, "aa02d69a-8755-4fde-8f29-cb653d8777c1");

  event.relationship_count = 2;
  event.relationships = malloc(sizeof(struct MBRelationship) *
			       event.relationship_count);
  event.relationships[0].type = 798;
  strcpy(event.relationships[0].musicbrainzID,
	 "4883461e-b471-4087-a9d2-ed9d8ed54a84");
  event.relationships[0].backward = 1;

  event.relationships[1].type = 798;
  strcpy(event.relationships[1].musicbrainzID,
	 "8018ee82-ad17-4555-a306-ce9942891b64");
  event.relationships[1].backward = 1;

  /*
  */
  event.url_count = 1;
  event.urls = malloc(sizeof(struct MBURL) * event.url_count);
  event.urls[0].type = 783;
  event.urls[0].address = "https://www.facebook.com/events/1719531021615601";

  /*
  place.url_count = 1;
  place.urls = malloc(sizeof(struct MBURL) * place.url_count);
  place.urls[0].type = 363;
  place.urls[0].address = "http://tendertrapbk.com/";

  place.urls[0].type = 429;
  place.urls[0].address = "https://www.facebook.com/SolasBarNYC";
  */
  
  mbs = mb_initialize();
  printf("L146\n");

  login_status = mb_login(mbs, "myuser", "mypw");
  printf("L142: login_status is %d\n", login_status);
  if(login_status == 0)
  {
    printf("L145\n");
    /*
    int areaid = lookup_area(mbs, "75e398a3-5f3f-4224-9cd8-0fe44715bc95");
    */
    /*
    do_add_artist(mbs);
    do_add_place(mbs);
    mb_add_place(mbs, place);
    */
    mb_add_event(mbs, event, &mbid);
  }
  else
  {
    printf("login failed\n");
  }
  /*
  free(place.urls);
  */

}
